/*
	QT؂̎
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_LEN  128			/* O̔z */

/*--- j[ ---*/
typedef enum {
	Term, Insert, Search, Print
} Menu;

/*--- Q؂̃m[h ---*/
typedef struct __bnode {
	char name[MAX_LEN];			/* O */
	struct __bnode *left;		/* ̎qm[hւ̃|C^ */
	struct __bnode *right;		/* E̎qm[hւ̃|C^ */
} BinNode;

/*--- m[h̊m ---*/
BinNode *AllocNode(void)
{
	return calloc(1, sizeof(BinNode));
}

/*--- m[h̑} ---*/
BinNode *InsertNode(BinNode *p, const BinNode *w)
{
	int cond;

	if (p == NULL) {
		p = AllocNode();
		strcpy(p->name, w->name);
		p->left = p->right = NULL;
	} else if ((cond = strcmp(w->name, p->name)) == 0)
		printf("yG[z%s͊ɓo^Ă܂B\n", w->name);
	else if (cond < 0)
		p->left	 = InsertNode(p->left, w);		/* ̎qɒ */
	else
		p->right = InsertNode(p->right, w);		/* E̎qɒ */
	return p;
}

/*--- m[h̒T ---*/
void SearchNode(BinNode *p, const BinNode *w)
{
	int cond;

	if (p == NULL)
		printf("%s͓o^Ă܂B\n", w->name);
	else if ((cond = strcmp(w->name, p->name)) == 0)
		printf("%s͓o^Ă܂B\n",   w->name);
	else if (cond < 0)
		SearchNode(p->left,  w);				/* ؂T */
	else
		SearchNode(p->right, w);				/* E؂T */
}

/*--- ؂̑SvfL[l̏ɕ\ ---*/
void PrintTree(const BinNode *p)
{
	if (p != NULL) {
		PrintTree(p->left);						/* p̍؂\ */
		printf("%s\n", p->name);				/* p\ */
		PrintTree(p->right);					/* p̉E؂\ */
	}
}

/*--- ؂̑Svf ---*/
void FreeTree(BinNode *p)
{
	if (p != NULL) {
		FreeTree(p->left);						/* p̍؂ */
		FreeTree(p->right);						/* p̉E؂ */
		free(p);								/* p */
	}
}

/*--- f[^̓ ---*/
BinNode Read(const char *message)
{
	BinNode temp;

	printf("%s閼O͂Ă : ", message);
	scanf("%s", temp.name);
	return temp;
}

/*--- j[I ---*/
Menu SelectMenu(void)
{
	int ch;

	do {
		printf("\n(1)}  (2)T  (3)\  (0)I : ");
		scanf("%d", &ch);
	} while (ch < Term	||	ch > Print);
	return (Menu)ch;
}

/*--- C֐ ---*/
int main(void)
{
	Menu    menu;
	BinNode *root;			/* ւ̃|C^ */

	root = NULL;
	do {
		BinNode x;
		switch (menu = SelectMenu()) {
		 case Insert :	x = Read("}");
						root = InsertNode(root, &x);
						break;
		 case Search :	x = Read("T");
						SearchNode(root, &x);
						break;
		 case Print	 :	puts("--- ꗗ\ ---");
						PrintTree(root);
						break;
		}
	} while (menu != Term);

	FreeTree(root);			/* ׂẴm[h */

	return 0;
}
